/**
 * ORY Hydra
 * Welcome to the ORY Hydra HTTP API documentation. You will find documentation for all HTTP APIs here.
 *
 * OpenAPI spec version: latest
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OryHydra) {
      root.OryHydra = {};
    }
    root.OryHydra.LogoutRequest = factory(root.OryHydra.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The LogoutRequest model module.
   * @module model/LogoutRequest
   * @version latest
   */

  /**
   * Constructs a new <code>LogoutRequest</code>.
   * @alias module:model/LogoutRequest
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>LogoutRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/LogoutRequest} obj Optional instance to populate.
   * @return {module:model/LogoutRequest} The populated <code>LogoutRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('request_url')) {
        obj['request_url'] = ApiClient.convertToType(data['request_url'], 'String');
      }
      if (data.hasOwnProperty('rp_initiated')) {
        obj['rp_initiated'] = ApiClient.convertToType(data['rp_initiated'], 'Boolean');
      }
      if (data.hasOwnProperty('sid')) {
        obj['sid'] = ApiClient.convertToType(data['sid'], 'String');
      }
      if (data.hasOwnProperty('subject')) {
        obj['subject'] = ApiClient.convertToType(data['subject'], 'String');
      }
    }
    return obj;
  }

  /**
   * RequestURL is the original Logout URL requested.
   * @member {String} request_url
   */
  exports.prototype['request_url'] = undefined;
  /**
   * RPInitiated is set to true if the request was initiated by a Relying Party (RP), also known as an OAuth 2.0 Client.
   * @member {Boolean} rp_initiated
   */
  exports.prototype['rp_initiated'] = undefined;
  /**
   * SessionID is the login session ID that was requested to log out.
   * @member {String} sid
   */
  exports.prototype['sid'] = undefined;
  /**
   * Subject is the user for whom the logout was request.
   * @member {String} subject
   */
  exports.prototype['subject'] = undefined;



  return exports;
}));


